package parsing

import (
	"errors"
	"math/big"
	"os"
)

type Cliargs struct {
	value *big.Int
}

func (arg *Cliargs) Parse() (*big.Int, error) {
	args := os.Args[1:]
	if len(args) != 1 {
		return nil, errors.New("only expected 1 arg")
	}
	num, success := new(big.Int).SetString(args[0], 10)
	if !success {
		return nil, errors.New("argument is not an integer")
	}
	arg.value = num
	return num, nil
}

func (arg *Cliargs) GetNumber() *big.Int {
	return arg.value
}
